/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { ButtonBaseType_$type } from "./ButtonBaseType";
import { ButtonBaseTarget_$type } from "./ButtonBaseTarget";
import { SizableComponentSize_$type } from "./SizableComponentSize";
import { VoidEventArgs } from "./VoidEventArgs";
/**
 * @hidden
 */
export let ButtonBase = /*@__PURE__*/ (() => {
    class ButtonBase extends BaseElement {
        constructor() {
            super(...arguments);
            this.clicked = null;
            this.g = new WCNativeHelper();
            this.j = null;
            this.focus = null;
            this.blur = null;
        }
        clickedChanged() {
            if (this.clicked != null) {
                this.h.o("click", (a) => this.clicked(this, VoidEventArgs.b(a)), false);
            }
            else {
                this.h.r("click");
            }
        }
        get h() {
            return this.g;
        }
        get nativeElement() {
            return this.j;
        }
        set nativeElement(a) {
            this.j = a;
            this.g.l = this.j;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get b() {
            let ret_ = this.h.k("type");
            ret_ = enumGetBox(ButtonBaseType_$type, EnumUtil.getEnumValue(ButtonBaseType_$type, this.h.f(ButtonBaseType_$type, ret_)));
            return EnumUtil.getEnumValue(ButtonBaseType_$type, ret_);
        }
        set b(a) {
            let value_ = enumGetBox(ButtonBaseType_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.h.s("type", value_);
        }
        get n() {
            let ret_ = this.h.k("href");
            return ret_;
        }
        set n(a) {
            let value_ = a;
            this.h.s("href", value_);
        }
        get m() {
            let ret_ = this.h.k("download");
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.h.s("download", value_);
        }
        get a() {
            let ret_ = this.h.k("target");
            ret_ = enumGetBox(ButtonBaseTarget_$type, EnumUtil.getEnumValue(ButtonBaseTarget_$type, this.h.f(ButtonBaseTarget_$type, ret_)));
            return EnumUtil.getEnumValue(ButtonBaseTarget_$type, ret_);
        }
        set a(a) {
            let value_ = enumGetBox(ButtonBaseTarget_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.h.s("target", value_);
        }
        get o() {
            let ret_ = this.h.k("rel");
            return ret_;
        }
        set o(a) {
            let value_ = a;
            this.h.s("rel", value_);
        }
        get i() {
            let ret_ = this.h.k("disabled");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.h.s("disabled", value_);
        }
        get l() {
            let ret_ = this.h.k("ariaLabel");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.h.s("ariaLabel", value_);
        }
        get c() {
            let ret_ = this.h.k("size");
            ret_ = enumGetBox(SizableComponentSize_$type, EnumUtil.getEnumValue(SizableComponentSize_$type, this.h.f(SizableComponentSize_$type, ret_)));
            return EnumUtil.getEnumValue(SizableComponentSize_$type, ret_);
        }
        set c(a) {
            let value_ = enumGetBox(SizableComponentSize_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.h.s("size", value_);
        }
        focusChanged() {
            if (this.focus != null) {
                this.h.o("focus", (a) => this.focus(this, VoidEventArgs.b(a)));
            }
            else {
                this.h.r("focus");
            }
        }
        blurChanged() {
            if (this.blur != null) {
                this.h.o("blur", (a) => this.blur(this, VoidEventArgs.b(a)));
            }
            else {
                this.h.r("blur");
            }
        }
        t(a) {
            this.nativeElement.focus(this.h.h(a));
        }
        q() {
            this.nativeElement.blur();
        }
    }
    ButtonBase.$t = /*@__PURE__*/ markType(ButtonBase, 'ButtonBase', BaseElement.$);
    return ButtonBase;
})();
