/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { ComboDir_$type } from "./ComboDir";
import { GroupingDirection_$type } from "./GroupingDirection";
import { FilteringOptions } from "./FilteringOptions";
import { ComboChangeEventArgs } from "./ComboChangeEventArgs";
import { VoidEventArgs } from "./VoidEventArgs";
/**
 * @hidden
 */
export let Combo = /*@__PURE__*/ (() => {
    class Combo extends BaseElement {
        constructor() {
            super(...arguments);
            this.m = new WCNativeHelper();
            this.y = null;
            this.change = null;
            this.focus = null;
            this.blur = null;
            this.opening = null;
            this.opened = null;
            this.closing = null;
            this.closed = null;
            this.ab = null;
            this.aa = null;
        }
        get n() {
            return this.m;
        }
        get nativeElement() {
            return this.y;
        }
        set nativeElement(a) {
            this.y = a;
            this.m.l = this.y;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get a() {
            let ret_ = this.n.k("data");
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.n.s("data", value_);
        }
        get af() {
            let ret_ = this.n.k("name");
            return ret_;
        }
        set af(a) {
            let value_ = a;
            this.n.s("name", value_);
        }
        get r() {
            let ret_ = this.n.k("disabled");
            return ret_;
        }
        set r(a) {
            let value_ = a;
            this.n.s("disabled", value_);
        }
        get w() {
            let ret_ = this.n.k("required");
            return ret_;
        }
        set w(a) {
            let value_ = a;
            this.n.s("required", value_);
        }
        get t() {
            let ret_ = this.n.k("invalid");
            return ret_;
        }
        set t(a) {
            let value_ = a;
            this.n.s("invalid", value_);
        }
        get v() {
            let ret_ = this.n.k("outlined");
            return ret_;
        }
        set v(a) {
            let value_ = a;
            this.n.s("outlined", value_);
        }
        get x() {
            let ret_ = this.n.k("singleSelect");
            return ret_;
        }
        set x(a) {
            let value_ = a;
            this.n.s("singleSelect", value_);
        }
        get o() {
            let ret_ = this.n.k("autofocus");
            return ret_;
        }
        set o(a) {
            let value_ = a;
            this.n.s("autofocus", value_);
        }
        get p() {
            let ret_ = this.n.k("autofocusList");
            return ret_;
        }
        set p(a) {
            let value_ = a;
            this.n.s("autofocusList", value_);
        }
        get ae() {
            let ret_ = this.n.k("label");
            return ret_;
        }
        set ae(a) {
            let value_ = a;
            this.n.s("label", value_);
        }
        get ag() {
            let ret_ = this.n.k("placeholder");
            return ret_;
        }
        set ag(a) {
            let value_ = a;
            this.n.s("placeholder", value_);
        }
        get ah() {
            let ret_ = this.n.k("placeholderSearch");
            return ret_;
        }
        set ah(a) {
            let value_ = a;
            this.n.s("placeholderSearch", value_);
        }
        get d() {
            let ret_ = this.n.k("dir");
            ret_ = enumGetBox(ComboDir_$type, EnumUtil.getEnumValue(ComboDir_$type, this.n.f(ComboDir_$type, ret_)));
            return EnumUtil.getEnumValue(ComboDir_$type, ret_);
        }
        set d(a) {
            let value_ = enumGetBox(ComboDir_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.n.s("dir", value_);
        }
        get u() {
            let ret_ = this.n.k("open");
            return ret_;
        }
        set u(a) {
            let value_ = a;
            this.n.s("open", value_);
        }
        get ai() {
            let ret_ = this.n.k("valueKey");
            return ret_;
        }
        set ai(a) {
            let value_ = a;
            this.n.s("valueKey", value_);
        }
        get ac() {
            let ret_ = this.n.k("displayKey");
            return ret_;
        }
        set ac(a) {
            let value_ = a;
            this.n.s("displayKey", value_);
        }
        get ad() {
            let ret_ = this.n.k("groupKey");
            return ret_;
        }
        set ad(a) {
            let value_ = a;
            this.n.s("groupKey", value_);
        }
        get f() {
            let ret_ = this.n.k("groupSorting");
            ret_ = enumGetBox(GroupingDirection_$type, EnumUtil.getEnumValue(GroupingDirection_$type, this.n.f(GroupingDirection_$type, ret_)));
            return EnumUtil.getEnumValue(GroupingDirection_$type, ret_);
        }
        set f(a) {
            let value_ = enumGetBox(GroupingDirection_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.n.s("groupSorting", value_);
        }
        get e() {
            let ret_ = this.n.j("filteringOptions", (a) => new FilteringOptions());
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.n.s("filteringOptions", value_);
        }
        get q() {
            let ret_ = this.n.k("caseSensitiveIcon");
            return ret_;
        }
        set q(a) {
            let value_ = a;
            this.n.s("caseSensitiveIcon", value_);
        }
        get s() {
            let ret_ = this.n.k("disableFiltering");
            return ret_;
        }
        set s(a) {
            let value_ = a;
            this.n.s("disableFiltering", value_);
        }
        get b() {
            let ret_ = this.n.k("value");
            return ret_;
        }
        set b(a) {
            let value_ = a;
            this.n.s("value", value_);
        }
        changeChanged() {
            if (this.change != null) {
                this.n.o("change", (a) => this.change(this, ComboChangeEventArgs.a(a)));
            }
            else {
                this.n.r("change");
            }
        }
        focusChanged() {
            if (this.focus != null) {
                this.n.o("focus", (a) => this.focus(this, VoidEventArgs.b(a)));
            }
            else {
                this.n.r("focus");
            }
        }
        blurChanged() {
            if (this.blur != null) {
                this.n.o("blur", (a) => this.blur(this, VoidEventArgs.b(a)));
            }
            else {
                this.n.r("blur");
            }
        }
        openingChanged() {
            if (this.opening != null) {
                this.n.o("opening", (a) => this.opening(this, VoidEventArgs.b(a)));
            }
            else {
                this.n.r("opening");
            }
        }
        openedChanged() {
            if (this.opened != null) {
                this.n.o("opened", (a) => this.opened(this, VoidEventArgs.b(a)));
            }
            else {
                this.n.r("opened");
            }
        }
        closingChanged() {
            if (this.closing != null) {
                this.n.o("closing", (a) => this.closing(this, VoidEventArgs.b(a)));
            }
            else {
                this.n.r("closing");
            }
        }
        closedChanged() {
            if (this.closed != null) {
                this.n.o("closed", (a) => this.closed(this, VoidEventArgs.b(a)));
            }
            else {
                this.n.r("closed");
            }
        }
        av() {
            this.nativeElement.reportValidity();
        }
        am() {
            this.nativeElement.checkValidity();
        }
        ar(a) {
            this.nativeElement.focus(this.n.h(a));
        }
        ak() {
            this.nativeElement.blur();
        }
        aw(a) {
            this.nativeElement.select(this.n.h(a));
        }
        ap(a) {
            this.nativeElement.deselect(this.n.h(a));
        }
        ay() {
            this.nativeElement.show();
        }
        as() {
            this.nativeElement.hide();
        }
        az() {
            this.nativeElement.toggle();
        }
    }
    Combo.$t = /*@__PURE__*/ markType(Combo, 'Combo', BaseElement.$);
    return Combo;
})();
