/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { InputBase } from "./InputBase";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { InputType_$type } from "./InputType";
import { InputInputmode_$type } from "./InputInputmode";
import { ComponentValueChangedEventArgs } from "./ComponentValueChangedEventArgs";
/**
 * @hidden
 */
export let Input = /*@__PURE__*/ (() => {
    class Input extends InputBase {
        constructor() {
            super(...arguments);
            this.change = null;
        }
        changeChanged() {
            if (this.change != null) {
                this.f.o("change", (a) => this.change(this, ComponentValueChangedEventArgs.a(a)));
            }
            else {
                this.f.r("change");
            }
        }
        get am() {
            let ret_ = this.f.k("value");
            return ret_;
        }
        set am(a) {
            let value_ = a;
            this.f.s("value", value_);
        }
        get ab() {
            let ret_ = this.f.k("type");
            ret_ = enumGetBox(InputType_$type, EnumUtil.getEnumValue(InputType_$type, this.f.f(InputType_$type, ret_)));
            return EnumUtil.getEnumValue(InputType_$type, ret_);
        }
        set ab(a) {
            let value_ = enumGetBox(InputType_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.f.s("type", value_);
        }
        get aa() {
            let ret_ = this.f.k("inputmode");
            ret_ = enumGetBox(InputInputmode_$type, EnumUtil.getEnumValue(InputInputmode_$type, this.f.f(InputInputmode_$type, ret_)));
            return EnumUtil.getEnumValue(InputInputmode_$type, ret_);
        }
        set aa(a) {
            let value_ = enumGetBox(InputInputmode_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.f.s("inputmode", value_);
        }
        get al() {
            let ret_ = this.f.k("pattern");
            return ret_;
        }
        set al(a) {
            let value_ = a;
            this.f.s("pattern", value_);
        }
        get ad() {
            let ret_ = this.f.k("invalid");
            return ret_;
        }
        set ad(a) {
            let value_ = a;
            this.f.s("invalid", value_);
        }
        get af() {
            let ret_ = this.f.k("minlength");
            return ret_;
        }
        set af(a) {
            let value_ = a;
            this.f.s("minlength", value_);
        }
        get ae() {
            let ret_ = this.f.k("maxlength");
            return ret_;
        }
        set ae(a) {
            let value_ = a;
            this.f.s("maxlength", value_);
        }
        get ak() {
            let ret_ = this.f.k("min");
            return ret_;
        }
        set ak(a) {
            let value_ = a;
            this.f.s("min", value_);
        }
        get aj() {
            let ret_ = this.f.k("max");
            return ret_;
        }
        set aj(a) {
            let value_ = a;
            this.f.s("max", value_);
        }
        get ag() {
            let ret_ = this.f.k("step");
            return ret_;
        }
        set ag(a) {
            let value_ = a;
            this.f.s("step", value_);
        }
        get ac() {
            let ret_ = this.f.k("autofocus");
            return ret_;
        }
        set ac(a) {
            let value_ = a;
            this.f.s("autofocus", value_);
        }
        get ai() {
            let ret_ = this.f.k("autocomplete");
            return ret_;
        }
        set ai(a) {
            let value_ = a;
            this.f.s("autocomplete", value_);
        }
        get ah() {
            let ret_ = this.f.k("tabIndex");
            return ret_;
        }
        set ah(a) {
            let value_ = a;
            this.f.s("tabIndex", value_);
        }
        ap() {
            this.nativeElement.reportValidity();
        }
        ao() {
            this.nativeElement.checkValidity();
        }
        ar(a) {
            this.nativeElement.setCustomValidity(this.f.h(a));
        }
        aq() {
            this.nativeElement.select();
        }
        at(a) {
            this.nativeElement.stepUp(this.f.h(a));
        }
        as(a) {
            this.nativeElement.stepDown(this.f.h(a));
        }
    }
    Input.$t = /*@__PURE__*/ markType(Input, 'Input', InputBase.$);
    return Input;
})();
