/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, IList_$type, typeCast, Boolean_$type, String_$type, Delegate_$type, Type, getBoxIfEnum, markType, EnumUtil } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { toSpinal } from "igniteui-react-core";
/**
 * @hidden
 */
export let WCNativeHelper = /*@__PURE__*/ (() => {
    class WCNativeHelper extends Base {
        constructor() {
            super(...arguments);
            this.e = null;
            this.a = new Dictionary$2(String_$type, Delegate_$type, 0);
            this.b = new Dictionary$2(String_$type, Delegate_$type, 0);
            this.d = new Dictionary$2(String_$type, Base.$, 0);
            this.c = new Dictionary$2(String_$type, Base.$, 0);
        }
        get l() {
            return this.e;
        }
        set l(a) {
            let val_ = a;
            if ((val_.___wcElement)) {
                val_ = val_.___wcElement;
            }
            this.e = val_;
        }
        k(propertyName_) {
            let target_ = this.l;
            let a = target_[propertyName_];
            return a;
        }
        j(propertyName_, a) {
            let target_ = this.l;
            let b = target_[propertyName_];
            b = this.g(b, a);
            return b;
        }
        i(propertyName_, a, b) {
            let target_ = this.l;
            let c = target_[propertyName_];
            if (c == null || c == undefined) {
                return null;
            }
            c = this.g(c, b);
            if (!(typeCast(IList_$type, c) !== null)) {
                let d = a(c);
                let e = c;
                for (let f = 0; f < e.length; f++) {
                    d.add(e[f]);
                }
                c = d;
            }
            return c;
        }
        g(obj_, a) {
            if (obj_ == null || obj_ == undefined) {
                return null;
            }
            if (obj_ != null) {
                if ((obj_.___wcElement)) {
                    obj_ = obj_.___wcElement;
                }
            }
            if (obj_ != null) {
                if ((obj_._implementation) || ((obj_.nativeElement) && (obj_.setNativeElement))) {
                    return obj_;
                }
            }
            if (obj_ != null) {
                let arr_ = (Array.isArray(obj_) ? obj_ : null);
                if (arr_ != null) {
                    let b = new Array(arr_.length);
                    for (let c = 0; c < arr_.length; c++) {
                        b[c] = this.g(arr_[c], a);
                    }
                    return b;
                }
            }
            let d = (obj_.externalObject);
            let ext_ = null;
            if (!d) {
                ext_ = a(obj_);
                if (ext_ != obj_) {
                    obj_.externalObject = ext_;
                    if ((ext_.setNativeElement)) {
                        ext_.setNativeElement(obj_);
                    }
                    else {
                        return obj_;
                    }
                }
            }
            else {
                ext_ = obj_.externalObject;
            }
            return ext_;
        }
        h(obj_) {
            if (obj_ == null) {
                return obj_;
            }
            let arr_ = (Array.isArray(obj_) ? obj_ : null);
            if (arr_ != null) {
                let a = new Array(arr_.length);
                for (let b = 0; b < arr_.length; b++) {
                    a[b] = this.h(arr_[b]);
                }
                return a;
            }
            if (obj_ != null && (obj_._implementation)) {
                obj_ = obj_._implementation;
            }
            if (obj_ != null && (obj_.$type) && (obj_.setNativeElement)) {
                obj_ = obj_.nativeElement;
            }
            if (obj_ != null && (obj_._ngElementStrategy) && (obj_._ngElementStrategy.componentRef) && (obj_._ngElementStrategy.componentRef.instance)) {
                obj_ = obj_._ngElementStrategy.componentRef.instance;
            }
            return obj_;
        }
        s(propertyName_, value_) {
            let target_ = this.l;
            if (typeCast(Boolean_$type, value_) !== null) {
                let a = (toSpinal(propertyName_));
                let b = value_;
                if (b) {
                    target_.setAttribute(propertyName_, "");
                }
                else {
                    target_.removeAttribute(propertyName_);
                }
            }
            target_[propertyName_] = value_;
        }
        static n(a) {
            if (a == null) {
                return a;
            }
            return a.substr(0, 1).toUpperCase() + a.substr(1);
        }
        static m(a) {
            if (a == null) {
                return a;
            }
            return a.substr(0, 1).toLowerCase() + a.substr(1);
        }
        o(a, b, c = true) {
            let wcName_ = "igc" + WCNativeHelper.n(a);
            if (!c) {
                wcName_ = a;
            }
            let d = null;
            let e = null;
            if (this.a.containsKey(a)) {
                d = this.a.item(a);
                e = this.b.item(a);
            }
            let f = b;
            let target_ = this.l;
            if (d != null) {
                let old_ = e;
                target_.removeEventListener(wcName_, old_);
                this.a.removeItem(a);
                this.b.removeItem(a);
            }
            if (f != null) {
                let nativeHandler_ = (ev_) => {
                    let g = null;
                    if (ev_ != null) {
                        g = ev_.detail;
                    }
                    f(g);
                };
                this.a.addItem(a, f);
                this.b.addItem(a, nativeHandler_);
                target_.addEventListener(wcName_, nativeHandler_);
            }
        }
        p(a, b, c) {
            let d = null;
            let e = null;
            if (this.d.containsKey(a)) {
                d = this.d.item(a);
                e = this.c.item(a);
            }
            let f = c;
            let target_ = this.l;
            let g = null;
            if (d != null) {
                let old_ = d;
                this.d.removeItem(a);
                this.c.removeItem(a);
                g = null;
            }
            if (f != null) {
                let nativeTemplate_ = (args_) => {
                    let h = (args_.externalObject);
                    let ext_ = null;
                    if (!h) {
                        ext_ = b(args_);
                        if (ext_ != args_) {
                            args_.externalObject = ext_;
                            ext_.setNativeElement(args_);
                        }
                    }
                    else {
                        ext_ = args_.externalObject;
                    }
                    return f(ext_);
                };
                this.q(nativeTemplate_, f);
                this.d.addItem(a, f);
                this.c.addItem(a, nativeTemplate_);
                g = nativeTemplate_;
            }
            this.s(a, g);
        }
        f($t, a) {
            if (typeof a === 'string') {
                let b = Type.createInstance($t);
                let c = EnumUtil.tryParse$1($t, a, true, b);
                b = c.p2;
                return getBoxIfEnum($t, b);
            }
            return a;
        }
        q(nativeTemplate_, newTemplate_) {
            if ((newTemplate_.___isBridged)) {
                nativeTemplate_.___isBridged = newTemplate_.___isBridged;
                nativeTemplate_.___templateId = newTemplate_.___templateId;
                nativeTemplate_.___containerId = newTemplate_.___containerId;
                nativeTemplate_.___container = newTemplate_.___container;
                nativeTemplate_.___onTemplateInit = newTemplate_.___onTemplateInit;
                nativeTemplate_.___onTemplateTeardown = newTemplate_.___onTemplateTeardown;
                nativeTemplate_.___checkHost = newTemplate_.___checkHost;
                nativeTemplate_.___onTemplateContextChanged = newTemplate_.___onTemplateContextChanged;
            }
        }
        r(a) {
            let wcName_ = "igc" + WCNativeHelper.n(a);
            let target_ = this.l;
            let b = null;
            let c = null;
            if (this.a.containsKey(a)) {
                b = this.a.item(a);
                c = this.b.item(a);
            }
            if (b != null) {
                let old_ = c;
                target_.removeEventListener(wcName_, old_);
                this.a.removeItem(a);
                this.b.removeItem(a);
            }
        }
    }
    WCNativeHelper.$t = /*@__PURE__*/ markType(WCNativeHelper, 'WCNativeHelper');
    return WCNativeHelper;
})();
