import { ComboChangeType_$type } from "./ComboChangeType";
import { ComboChangeEventArgsDetail as ComboChangeEventArgsDetail_internal } from "./ComboChangeEventArgsDetail";
import { ensureEnum } from "igniteui-react-core";
export class IgrComboChangeEventArgsDetail {
    createImplementation() {
        return new ComboChangeEventArgsDetail_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get newValue() {
        return this.i.g;
    }
    set newValue(v) {
        this.i.g = v;
    }
    get items() {
        return this.i.e;
    }
    set items(v) {
        this.i.e = v;
    }
    get changeType() {
        return this.i.a;
    }
    set changeType(v) {
        this.i.a = ensureEnum(ComboChangeType_$type, v);
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
}
