/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { markType } from "igniteui-react-core";
/**
 * @hidden
 */
var TreeItem = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreeItem, _super);
    function TreeItem() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new WCNativeHelper();
        _this.j = null;
        return _this;
    }
    Object.defineProperty(TreeItem.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeItem.prototype, "nativeElement", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            this.j = a;
            this.b.l = this.j;
        },
        enumerable: false,
        configurable: true
    });
    TreeItem.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(TreeItem.prototype, "a", {
        get: function () {
            var ret_ = this.c.j("parent", function (a) { return new TreeItem(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.s("parent", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeItem.prototype, "i", {
        get: function () {
            var ret_ = this.c.k("level");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.s("level", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeItem.prototype, "m", {
        get: function () {
            var ret_ = this.c.k("label");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.s("label", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeItem.prototype, "f", {
        get: function () {
            var ret_ = this.c.k("expanded");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.s("expanded", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeItem.prototype, "d", {
        get: function () {
            var ret_ = this.c.k("active");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.s("active", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeItem.prototype, "e", {
        get: function () {
            var ret_ = this.c.k("disabled");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.s("disabled", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeItem.prototype, "h", {
        get: function () {
            var ret_ = this.c.k("selected");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.s("selected", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeItem.prototype, "g", {
        get: function () {
            var ret_ = this.c.k("loading");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.s("loading", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeItem.prototype, "l", {
        get: function () {
            var ret_ = this.c.k("value");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.s("value", value_);
        },
        enumerable: false,
        configurable: true
    });
    TreeItem.prototype.p = function () {
        this.nativeElement.connectedCallback();
    };
    TreeItem.prototype.q = function () {
        this.nativeElement.disconnectedCallback();
    };
    TreeItem.prototype.s = function () {
        this.nativeElement.expandWithEvent();
    };
    TreeItem.prototype.o = function () {
        this.nativeElement.collapseWithEvent();
    };
    TreeItem.prototype.u = function () {
        this.nativeElement.toggle();
    };
    TreeItem.prototype.r = function () {
        this.nativeElement.expand();
    };
    TreeItem.prototype.n = function () {
        this.nativeElement.collapse();
    };
    TreeItem.$t = markType(TreeItem, 'TreeItem', BaseElement.$);
    return TreeItem;
}(BaseElement));
export { TreeItem };
