import { ComboChangeType_$type } from "./ComboChangeType";
import { ComboChangeEventArgsDetail as ComboChangeEventArgsDetail_internal } from "./ComboChangeEventArgsDetail";
import { ensureEnum } from "igniteui-react-core";
var IgrComboChangeEventArgsDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrComboChangeEventArgsDetail() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrComboChangeEventArgsDetail.prototype.createImplementation = function () {
        return new ComboChangeEventArgsDetail_internal();
    };
    Object.defineProperty(IgrComboChangeEventArgsDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrComboChangeEventArgsDetail.prototype.onImplementationCreated = function () {
    };
    IgrComboChangeEventArgsDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrComboChangeEventArgsDetail.prototype, "newValue", {
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrComboChangeEventArgsDetail.prototype, "items", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrComboChangeEventArgsDetail.prototype, "changeType", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = ensureEnum(ComboChangeType_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    IgrComboChangeEventArgsDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrComboChangeEventArgsDetail;
}());
export { IgrComboChangeEventArgsDetail };
