import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { Type } from "igniteui-react-core";
import { Step } from "./Step";
import { StepperOrientation } from "./StepperOrientation";
import { StepperStepType } from "./StepperStepType";
import { Direction } from "./Direction";
import { StepperTitlePosition } from "./StepperTitlePosition";
import { SizableComponentSize } from "./SizableComponentSize";
import { ActiveStepChangingArgsEventArgs } from "./ActiveStepChangingArgsEventArgs";
import { ActiveStepChangedArgsEventArgs } from "./ActiveStepChangedArgsEventArgs";
/**
 * @hidden
 */
export declare class Stepper extends BaseElement {
    static $t: Type;
    private i;
    protected get j(): WCNativeHelper;
    private m;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get a(): Step[];
    set a(a: Step[]);
    get f(): StepperOrientation;
    set f(a: StepperOrientation);
    get g(): StepperStepType;
    set g(a: StepperStepType);
    get l(): boolean;
    set l(a: boolean);
    get k(): boolean;
    set k(a: boolean);
    get d(): Direction;
    set d(a: Direction);
    get h(): StepperTitlePosition;
    set h(a: StepperTitlePosition);
    get e(): SizableComponentSize;
    set e(a: SizableComponentSize);
    activeStepChanging: (sender: any, args: ActiveStepChangingArgsEventArgs) => void;
    activeStepChangingChanged(): void;
    activeStepChanged: (sender: any, args: ActiveStepChangedArgsEventArgs) => void;
    activeStepChangedChanged(): void;
    q(): void;
    r(a: number): void;
    s(): void;
    t(): void;
    u(): void;
}
