import { IgrDragService } from "./igr-drag-service";
import { TabHeaderElement as TabHeaderElement_internal } from "./TabHeaderElement";
/**
 * Describes a tab header element.
*/
export declare class IgrTabHeaderElement {
    protected createImplementation(): TabHeaderElement_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): TabHeaderElement_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets/sets the drag service.
    */
    get dragService(): IgrDragService;
    set dragService(v: IgrDragService);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
