/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { DockManagerLayout } from "./DockManagerLayout";
import { DockManagerPane } from "./DockManagerPane";
import { DockManagerPoint } from "./DockManagerPoint";
import { ContentPane } from "./ContentPane";
import { DockManagerShowHeaderIconOnHover_$type } from "./DockManagerShowHeaderIconOnHover";
import { DockManagerResourceStrings } from "./DockManagerResourceStrings";
import { LayoutChangeEventArgs } from "./LayoutChangeEventArgs";
/**
 * @hidden
 */
export let DockManager = /*@__PURE__*/ (() => {
    class DockManager extends BaseElement {
        constructor() {
            super(...arguments);
            this.layoutChange = null;
            this.i = new WCNativeHelper();
            this.n = null;
        }
        layoutChangeChanged() {
            if (this.layoutChange != null) {
                this.j.o("layoutChange", (a) => this.layoutChange(this, LayoutChangeEventArgs.b(this.b)), false);
            }
            else {
                this.j.r("layoutChange");
            }
        }
        get j() {
            return this.i;
        }
        get nativeElement() {
            return this.n;
        }
        set nativeElement(a) {
            this.n = a;
            this.i.l = this.n;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get b() {
            let ret_ = this.j.j("layout", (a) => new DockManagerLayout());
            return ret_;
        }
        set b(a) {
            let value_ = a;
            this.j.s("layout", value_);
        }
        get c() {
            let ret_ = this.j.j("draggedPane", (a) => DockManagerPane.createFromNative(a));
            return ret_;
        }
        set c(a) {
            let value_ = a;
            this.j.s("draggedPane", value_);
        }
        get e() {
            let ret_ = this.j.j("dropPosition", (a) => new DockManagerPoint());
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.j.s("dropPosition", value_);
        }
        get a() {
            let ret_ = this.j.j("activePane", (a) => new ContentPane());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.j.s("activePane", value_);
        }
        get l() {
            let ret_ = this.j.k("allowMaximize");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.j.s("allowMaximize", value_);
        }
        get g() {
            let ret_ = this.j.k("showHeaderIconOnHover");
            ret_ = enumGetBox(DockManagerShowHeaderIconOnHover_$type, EnumUtil.getEnumValue(DockManagerShowHeaderIconOnHover_$type, this.j.f(DockManagerShowHeaderIconOnHover_$type, ret_)));
            return EnumUtil.getEnumValue(DockManagerShowHeaderIconOnHover_$type, ret_);
        }
        set g(a) {
            let value_ = enumGetBox(DockManagerShowHeaderIconOnHover_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.j.s("showHeaderIconOnHover", value_);
        }
        get d() {
            let ret_ = this.j.j("maximizedPane", (a) => DockManagerPane.createFromNative(a));
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.j.s("maximizedPane", value_);
        }
        get f() {
            let ret_ = this.j.j("resourceStrings", (a) => new DockManagerResourceStrings());
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.j.s("resourceStrings", value_);
        }
        get k() {
            let ret_ = this.j.k("allowFloatingPanesResize");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.j.s("allowFloatingPanesResize", value_);
        }
        get m() {
            let ret_ = this.j.k("disableKeyboardNavigation");
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.j.s("disableKeyboardNavigation", value_);
        }
    }
    DockManager.$t = /*@__PURE__*/ markType(DockManager, 'DockManager', BaseElement.$);
    return DockManager;
})();
