/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { SizableComponentSize_$type } from "./SizableComponentSize";
/**
 * @hidden
 */
export let Icon = /*@__PURE__*/ (() => {
    class Icon extends BaseElement {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.e = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.e;
        }
        set nativeElement(a) {
            this.e = a;
            this.b.l = this.e;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get h() {
            let ret_ = this.c.k("name");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.c.s("name", value_);
        }
        get g() {
            let ret_ = this.c.k("collection");
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.c.s("collection", value_);
        }
        get d() {
            let ret_ = this.c.k("mirrored");
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.c.s("mirrored", value_);
        }
        get a() {
            let ret_ = this.c.k("size");
            ret_ = enumGetBox(SizableComponentSize_$type, EnumUtil.getEnumValue(SizableComponentSize_$type, this.c.f(SizableComponentSize_$type, ret_)));
            return EnumUtil.getEnumValue(SizableComponentSize_$type, ret_);
        }
        set a(a) {
            let value_ = enumGetBox(SizableComponentSize_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.c.s("size", value_);
        }
        i() {
            this.nativeElement.connectedCallback();
        }
        j() {
            this.nativeElement.disconnectedCallback();
        }
        k(a, b, c) {
            this.nativeElement.registerIcon(this.c.h(a), this.c.h(b), this.c.h(c));
        }
        l(a, b, c) {
            this.nativeElement.registerIconFromText(this.c.h(a), this.c.h(b), this.c.h(c));
        }
    }
    Icon.$t = /*@__PURE__*/ markType(Icon, 'Icon', BaseElement.$);
    return Icon;
})();
