/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Dropdown } from "./Dropdown";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { SelectDir_$type } from "./SelectDir";
import { VoidEventArgs } from "./VoidEventArgs";
/**
 * @hidden
 */
export let Select = /*@__PURE__*/ (() => {
    class Select extends Dropdown {
        constructor() {
            super(...arguments);
            this.focus = null;
            this.blur = null;
        }
        get al() {
            let ret_ = this.i.k("value");
            return ret_;
        }
        set al(a) {
            let value_ = a;
            this.i.s("value", value_);
        }
        get aj() {
            let ret_ = this.i.k("name");
            return ret_;
        }
        set aj(a) {
            let value_ = a;
            this.i.s("name", value_);
        }
        get ae() {
            let ret_ = this.i.k("disabled");
            return ret_;
        }
        set ae(a) {
            let value_ = a;
            this.i.s("disabled", value_);
        }
        get ah() {
            let ret_ = this.i.k("required");
            return ret_;
        }
        set ah(a) {
            let value_ = a;
            this.i.s("required", value_);
        }
        get af() {
            let ret_ = this.i.k("invalid");
            return ret_;
        }
        set af(a) {
            let value_ = a;
            this.i.s("invalid", value_);
        }
        get ag() {
            let ret_ = this.i.k("outlined");
            return ret_;
        }
        set ag(a) {
            let value_ = a;
            this.i.s("outlined", value_);
        }
        get ad() {
            let ret_ = this.i.k("autofocus");
            return ret_;
        }
        set ad(a) {
            let value_ = a;
            this.i.s("autofocus", value_);
        }
        get ai() {
            let ret_ = this.i.k("label");
            return ret_;
        }
        set ai(a) {
            let value_ = a;
            this.i.s("label", value_);
        }
        get ak() {
            let ret_ = this.i.k("placeholder");
            return ret_;
        }
        set ak(a) {
            let value_ = a;
            this.i.s("placeholder", value_);
        }
        get aa() {
            let ret_ = this.i.k("dir");
            ret_ = enumGetBox(SelectDir_$type, EnumUtil.getEnumValue(SelectDir_$type, this.i.f(SelectDir_$type, ret_)));
            return EnumUtil.getEnumValue(SelectDir_$type, ret_);
        }
        set aa(a) {
            let value_ = enumGetBox(SelectDir_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.i.s("dir", value_);
        }
        focusChanged() {
            if (this.focus != null) {
                this.i.o("focus", (a) => this.focus(this, VoidEventArgs.b(a)));
            }
            else {
                this.i.r("focus");
            }
        }
        blurChanged() {
            if (this.blur != null) {
                this.i.o("blur", (a) => this.blur(this, VoidEventArgs.b(a)));
            }
            else {
                this.i.r("blur");
            }
        }
        ar(a) {
            this.nativeElement.focus(this.i.h(a));
        }
        an() {
            this.nativeElement.blur();
        }
        as() {
            this.nativeElement.reportValidity();
        }
        ao() {
            this.nativeElement.checkValidity();
        }
        ap() {
            this.nativeElement.firstUpdated();
        }
    }
    Select.$t = /*@__PURE__*/ markType(Select, 'Select', Dropdown.$);
    return Select;
})();
