/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { StepStepType_$type } from "./StepStepType";
import { StepTitlePosition_$type } from "./StepTitlePosition";
import { StepOrientation_$type } from "./StepOrientation";
/**
 * @hidden
 */
export let Step = /*@__PURE__*/ (() => {
    class Step extends BaseElement {
        constructor() {
            super(...arguments);
            this.d = new WCNativeHelper();
            this.p = null;
        }
        get e() {
            return this.d;
        }
        get nativeElement() {
            return this.p;
        }
        set nativeElement(a) {
            this.p = a;
            this.d.l = this.p;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get j() {
            let ret_ = this.e.k("invalid");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.e.s("invalid", value_);
        }
        get f() {
            let ret_ = this.e.k("active");
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.e.s("active", value_);
        }
        get l() {
            let ret_ = this.e.k("optional");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.e.s("optional", value_);
        }
        get i() {
            let ret_ = this.e.k("disabled");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.e.s("disabled", value_);
        }
        get g() {
            let ret_ = this.e.k("complete");
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.e.s("complete", value_);
        }
        get m() {
            let ret_ = this.e.k("previousComplete");
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.e.s("previousComplete", value_);
        }
        get b() {
            let ret_ = this.e.k("stepType");
            ret_ = enumGetBox(StepStepType_$type, EnumUtil.getEnumValue(StepStepType_$type, this.e.f(StepStepType_$type, ret_)));
            return EnumUtil.getEnumValue(StepStepType_$type, ret_);
        }
        set b(a) {
            let value_ = enumGetBox(StepStepType_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.e.s("stepType", value_);
        }
        get c() {
            let ret_ = this.e.k("titlePosition");
            ret_ = enumGetBox(StepTitlePosition_$type, EnumUtil.getEnumValue(StepTitlePosition_$type, this.e.f(StepTitlePosition_$type, ret_)));
            return EnumUtil.getEnumValue(StepTitlePosition_$type, ret_);
        }
        set c(a) {
            let value_ = enumGetBox(StepTitlePosition_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.e.s("titlePosition", value_);
        }
        get a() {
            let ret_ = this.e.k("orientation");
            ret_ = enumGetBox(StepOrientation_$type, EnumUtil.getEnumValue(StepOrientation_$type, this.e.f(StepOrientation_$type, ret_)));
            return EnumUtil.getEnumValue(StepOrientation_$type, ret_);
        }
        set a(a) {
            let value_ = enumGetBox(StepOrientation_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.e.s("orientation", value_);
        }
        get o() {
            let ret_ = this.e.k("index");
            return ret_;
        }
        set o(a) {
            let value_ = a;
            this.e.s("index", value_);
        }
        get h() {
            let ret_ = this.e.k("contentTop");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.e.s("contentTop", value_);
        }
        get k() {
            let ret_ = this.e.k("linearDisabled");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.e.s("linearDisabled", value_);
        }
        get n() {
            let ret_ = this.e.k("visited");
            return ret_;
        }
        set n(a) {
            let value_ = a;
            this.e.s("visited", value_);
        }
    }
    Step.$t = /*@__PURE__*/ markType(Step, 'Step', BaseElement.$);
    return Step;
})();
