/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { CalendarBase } from "./CalendarBase";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { CalendarHeaderOrientation_$type } from "./CalendarHeaderOrientation";
import { CalendarOrientation_$type } from "./CalendarOrientation";
import { CalendarActiveView_$type } from "./CalendarActiveView";
import { CalendarFormatOptions } from "./CalendarFormatOptions";
import { CalendarResourceStrings } from "./CalendarResourceStrings";
import { SizableComponentSize_$type } from "./SizableComponentSize";
import { ComponentDataValueChangedEventArgs } from "./ComponentDataValueChangedEventArgs";
/**
 * @hidden
 */
var Calendar = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Calendar, _super);
    function Calendar() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.change = null;
        return _this;
    }
    Object.defineProperty(Calendar.prototype, "w", {
        get: function () {
            var ret_ = this.f.k("value");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.s("value", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "l", {
        get: function () {
            var ret_ = this.f.k("values");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.s("values", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "v", {
        get: function () {
            var ret_ = this.f.k("activeDate");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.s("activeDate", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "u", {
        get: function () {
            var ret_ = this.f.k("hideOutsideDays");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.s("hideOutsideDays", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "t", {
        get: function () {
            var ret_ = this.f.k("hideHeader");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.s("hideHeader", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "o", {
        get: function () {
            var ret_ = this.f.k("headerOrientation");
            ret_ = enumGetBox(CalendarHeaderOrientation_$type, EnumUtil.getEnumValue(CalendarHeaderOrientation_$type, this.f.f(CalendarHeaderOrientation_$type, ret_)));
            return EnumUtil.getEnumValue(CalendarHeaderOrientation_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(CalendarHeaderOrientation_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.f.s("headerOrientation", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "p", {
        get: function () {
            var ret_ = this.f.k("orientation");
            ret_ = enumGetBox(CalendarOrientation_$type, EnumUtil.getEnumValue(CalendarOrientation_$type, this.f.f(CalendarOrientation_$type, ret_)));
            return EnumUtil.getEnumValue(CalendarOrientation_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(CalendarOrientation_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.f.s("orientation", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "x", {
        get: function () {
            var ret_ = this.f.k("visibleMonths");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.s("visibleMonths", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "m", {
        get: function () {
            var ret_ = this.f.k("activeView");
            ret_ = enumGetBox(CalendarActiveView_$type, EnumUtil.getEnumValue(CalendarActiveView_$type, this.f.f(CalendarActiveView_$type, ret_)));
            return EnumUtil.getEnumValue(CalendarActiveView_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(CalendarActiveView_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.f.s("activeView", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "n", {
        get: function () {
            var ret_ = this.f.j("formatOptions", function (a) { return new CalendarFormatOptions(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.s("formatOptions", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "q", {
        get: function () {
            var ret_ = this.f.j("resourceStrings", function (a) { return new CalendarResourceStrings(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.s("resourceStrings", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "s", {
        get: function () {
            var ret_ = this.f.k("size");
            ret_ = enumGetBox(SizableComponentSize_$type, EnumUtil.getEnumValue(SizableComponentSize_$type, this.f.f(SizableComponentSize_$type, ret_)));
            return EnumUtil.getEnumValue(SizableComponentSize_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(SizableComponentSize_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.f.s("size", value_);
        },
        enumerable: false,
        configurable: true
    });
    Calendar.prototype.changeChanged = function () {
        var _this = this;
        if (this.change != null) {
            this.f.o("change", function (a) { return _this.change(_this, ComponentDataValueChangedEventArgs.a(a)); });
        }
        else {
            this.f.r("change");
        }
    };
    Calendar.$t = markType(Calendar, 'Calendar', CalendarBase.$);
    return Calendar;
}(CalendarBase));
export { Calendar };
