/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { ComboDir_$type } from "./ComboDir";
import { GroupingDirection_$type } from "./GroupingDirection";
import { FilteringOptions } from "./FilteringOptions";
import { ComboChangeEventArgs } from "./ComboChangeEventArgs";
import { VoidEventArgs } from "./VoidEventArgs";
/**
 * @hidden
 */
var Combo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Combo, _super);
    function Combo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.m = new WCNativeHelper();
        _this.y = null;
        _this.change = null;
        _this.focus = null;
        _this.blur = null;
        _this.opening = null;
        _this.opened = null;
        _this.closing = null;
        _this.closed = null;
        _this.ab = null;
        _this.aa = null;
        return _this;
    }
    Object.defineProperty(Combo.prototype, "n", {
        get: function () {
            return this.m;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "nativeElement", {
        get: function () {
            return this.y;
        },
        set: function (a) {
            this.y = a;
            this.m.l = this.y;
        },
        enumerable: false,
        configurable: true
    });
    Combo.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(Combo.prototype, "a", {
        get: function () {
            var ret_ = this.n.k("data");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("data", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "af", {
        get: function () {
            var ret_ = this.n.k("name");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("name", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "r", {
        get: function () {
            var ret_ = this.n.k("disabled");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("disabled", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "w", {
        get: function () {
            var ret_ = this.n.k("required");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("required", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "t", {
        get: function () {
            var ret_ = this.n.k("invalid");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("invalid", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "v", {
        get: function () {
            var ret_ = this.n.k("outlined");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("outlined", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "x", {
        get: function () {
            var ret_ = this.n.k("singleSelect");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("singleSelect", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "o", {
        get: function () {
            var ret_ = this.n.k("autofocus");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("autofocus", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "p", {
        get: function () {
            var ret_ = this.n.k("autofocusList");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("autofocusList", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "ae", {
        get: function () {
            var ret_ = this.n.k("label");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("label", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "ag", {
        get: function () {
            var ret_ = this.n.k("placeholder");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("placeholder", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "ah", {
        get: function () {
            var ret_ = this.n.k("placeholderSearch");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("placeholderSearch", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "d", {
        get: function () {
            var ret_ = this.n.k("dir");
            ret_ = enumGetBox(ComboDir_$type, EnumUtil.getEnumValue(ComboDir_$type, this.n.f(ComboDir_$type, ret_)));
            return EnumUtil.getEnumValue(ComboDir_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(ComboDir_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.n.s("dir", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "u", {
        get: function () {
            var ret_ = this.n.k("open");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("open", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "ai", {
        get: function () {
            var ret_ = this.n.k("valueKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("valueKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "ac", {
        get: function () {
            var ret_ = this.n.k("displayKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("displayKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "ad", {
        get: function () {
            var ret_ = this.n.k("groupKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("groupKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "f", {
        get: function () {
            var ret_ = this.n.k("groupSorting");
            ret_ = enumGetBox(GroupingDirection_$type, EnumUtil.getEnumValue(GroupingDirection_$type, this.n.f(GroupingDirection_$type, ret_)));
            return EnumUtil.getEnumValue(GroupingDirection_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GroupingDirection_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.n.s("groupSorting", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "e", {
        get: function () {
            var ret_ = this.n.j("filteringOptions", function (a) { return new FilteringOptions(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("filteringOptions", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "q", {
        get: function () {
            var ret_ = this.n.k("caseSensitiveIcon");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("caseSensitiveIcon", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "s", {
        get: function () {
            var ret_ = this.n.k("disableFiltering");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("disableFiltering", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "b", {
        get: function () {
            var ret_ = this.n.k("value");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.n.s("value", value_);
        },
        enumerable: false,
        configurable: true
    });
    Combo.prototype.changeChanged = function () {
        var _this = this;
        if (this.change != null) {
            this.n.o("change", function (a) { return _this.change(_this, ComboChangeEventArgs.a(a)); });
        }
        else {
            this.n.r("change");
        }
    };
    Combo.prototype.focusChanged = function () {
        var _this = this;
        if (this.focus != null) {
            this.n.o("focus", function (a) { return _this.focus(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.n.r("focus");
        }
    };
    Combo.prototype.blurChanged = function () {
        var _this = this;
        if (this.blur != null) {
            this.n.o("blur", function (a) { return _this.blur(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.n.r("blur");
        }
    };
    Combo.prototype.openingChanged = function () {
        var _this = this;
        if (this.opening != null) {
            this.n.o("opening", function (a) { return _this.opening(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.n.r("opening");
        }
    };
    Combo.prototype.openedChanged = function () {
        var _this = this;
        if (this.opened != null) {
            this.n.o("opened", function (a) { return _this.opened(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.n.r("opened");
        }
    };
    Combo.prototype.closingChanged = function () {
        var _this = this;
        if (this.closing != null) {
            this.n.o("closing", function (a) { return _this.closing(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.n.r("closing");
        }
    };
    Combo.prototype.closedChanged = function () {
        var _this = this;
        if (this.closed != null) {
            this.n.o("closed", function (a) { return _this.closed(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.n.r("closed");
        }
    };
    Combo.prototype.av = function () {
        this.nativeElement.reportValidity();
    };
    Combo.prototype.am = function () {
        this.nativeElement.checkValidity();
    };
    Combo.prototype.ar = function (a) {
        this.nativeElement.focus(this.n.h(a));
    };
    Combo.prototype.ak = function () {
        this.nativeElement.blur();
    };
    Combo.prototype.aw = function (a) {
        this.nativeElement.select(this.n.h(a));
    };
    Combo.prototype.ap = function (a) {
        this.nativeElement.deselect(this.n.h(a));
    };
    Combo.prototype.ay = function () {
        this.nativeElement.show();
    };
    Combo.prototype.as = function () {
        this.nativeElement.hide();
    };
    Combo.prototype.az = function () {
        this.nativeElement.toggle();
    };
    Combo.$t = markType(Combo, 'Combo', BaseElement.$);
    return Combo;
}(BaseElement));
export { Combo };
