/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Dropdown } from "./Dropdown";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { SelectDir_$type } from "./SelectDir";
import { VoidEventArgs } from "./VoidEventArgs";
/**
 * @hidden
 */
var Select = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Select, _super);
    function Select() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.focus = null;
        _this.blur = null;
        return _this;
    }
    Object.defineProperty(Select.prototype, "al", {
        get: function () {
            var ret_ = this.i.k("value");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.s("value", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "aj", {
        get: function () {
            var ret_ = this.i.k("name");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.s("name", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ae", {
        get: function () {
            var ret_ = this.i.k("disabled");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.s("disabled", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ah", {
        get: function () {
            var ret_ = this.i.k("required");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.s("required", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "af", {
        get: function () {
            var ret_ = this.i.k("invalid");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.s("invalid", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ag", {
        get: function () {
            var ret_ = this.i.k("outlined");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.s("outlined", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ad", {
        get: function () {
            var ret_ = this.i.k("autofocus");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.s("autofocus", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ai", {
        get: function () {
            var ret_ = this.i.k("label");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.s("label", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ak", {
        get: function () {
            var ret_ = this.i.k("placeholder");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.s("placeholder", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "aa", {
        get: function () {
            var ret_ = this.i.k("dir");
            ret_ = enumGetBox(SelectDir_$type, EnumUtil.getEnumValue(SelectDir_$type, this.i.f(SelectDir_$type, ret_)));
            return EnumUtil.getEnumValue(SelectDir_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(SelectDir_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.i.s("dir", value_);
        },
        enumerable: false,
        configurable: true
    });
    Select.prototype.focusChanged = function () {
        var _this = this;
        if (this.focus != null) {
            this.i.o("focus", function (a) { return _this.focus(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.i.r("focus");
        }
    };
    Select.prototype.blurChanged = function () {
        var _this = this;
        if (this.blur != null) {
            this.i.o("blur", function (a) { return _this.blur(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.i.r("blur");
        }
    };
    Select.prototype.ar = function (a) {
        this.nativeElement.focus(this.i.h(a));
    };
    Select.prototype.an = function () {
        this.nativeElement.blur();
    };
    Select.prototype.as = function () {
        this.nativeElement.reportValidity();
    };
    Select.prototype.ao = function () {
        this.nativeElement.checkValidity();
    };
    Select.prototype.ap = function () {
        this.nativeElement.firstUpdated();
    };
    Select.$t = markType(Select, 'Select', Dropdown.$);
    return Select;
}(Dropdown));
export { Select };
