/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { SliderBaseTickOrientation_$type } from "./SliderBaseTickOrientation";
import { TickLabelRotation_$type } from "./TickLabelRotation";
/**
 * @hidden
 */
var SliderBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SliderBase, _super);
    function SliderBase() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = new WCNativeHelper();
        _this.r = null;
        return _this;
    }
    Object.defineProperty(SliderBase.prototype, "e", {
        get: function () {
            return this.d;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "nativeElement", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            this.r = a;
            this.d.l = this.r;
        },
        enumerable: false,
        configurable: true
    });
    SliderBase.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(SliderBase.prototype, "m", {
        get: function () {
            var ret_ = this.e.k("min");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.s("min", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "l", {
        get: function () {
            var ret_ = this.e.k("max");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.s("max", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "k", {
        get: function () {
            var ret_ = this.e.k("lowerBound");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.s("lowerBound", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "q", {
        get: function () {
            var ret_ = this.e.k("upperBound");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.s("upperBound", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "f", {
        get: function () {
            var ret_ = this.e.k("disabled");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.s("disabled", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "g", {
        get: function () {
            var ret_ = this.e.k("discreteTrack");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.s("discreteTrack", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "j", {
        get: function () {
            var ret_ = this.e.k("hideTooltip");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.s("hideTooltip", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "p", {
        get: function () {
            var ret_ = this.e.k("step");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.s("step", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "n", {
        get: function () {
            var ret_ = this.e.k("primaryTicks");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.s("primaryTicks", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "o", {
        get: function () {
            var ret_ = this.e.k("secondaryTicks");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.s("secondaryTicks", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "b", {
        get: function () {
            var ret_ = this.e.k("tickOrientation");
            ret_ = enumGetBox(SliderBaseTickOrientation_$type, EnumUtil.getEnumValue(SliderBaseTickOrientation_$type, this.e.f(SliderBaseTickOrientation_$type, ret_)));
            return EnumUtil.getEnumValue(SliderBaseTickOrientation_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(SliderBaseTickOrientation_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.e.s("tickOrientation", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "h", {
        get: function () {
            var ret_ = this.e.k("hidePrimaryLabels");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.s("hidePrimaryLabels", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "i", {
        get: function () {
            var ret_ = this.e.k("hideSecondaryLabels");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.s("hideSecondaryLabels", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "t", {
        get: function () {
            var ret_ = this.e.k("locale");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.s("locale", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "u", {
        get: function () {
            var ret_ = this.e.k("valueFormat");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.s("valueFormat", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SliderBase.prototype, "c", {
        get: function () {
            var ret_ = this.e.k("tickLabelRotation");
            ret_ = enumGetBox(TickLabelRotation_$type, EnumUtil.getEnumValue(TickLabelRotation_$type, this.e.f(TickLabelRotation_$type, ret_)));
            return EnumUtil.getEnumValue(TickLabelRotation_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(TickLabelRotation_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.e.s("tickLabelRotation", value_);
        },
        enumerable: false,
        configurable: true
    });
    SliderBase.prototype.v = function () {
        this.nativeElement.connectedCallback();
    };
    SliderBase.prototype.w = function () {
        this.nativeElement.disconnectedCallback();
    };
    Object.defineProperty(SliderBase.prototype, "a", {
        get: function () {
            var ret_ = this.e.k("valueFormatOptions");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.s("valueFormatOptions", value_);
        },
        enumerable: false,
        configurable: true
    });
    SliderBase.$t = markType(SliderBase, 'SliderBase', BaseElement.$);
    return SliderBase;
}(BaseElement));
export { SliderBase };
